<template>
    <main id="js-page-content" role="main" class="page-content">
        <ol class="breadcrumb page-breadcrumb">
            <li class="breadcrumb-item"><router-link to="/index">Dashboard</router-link></li>
            <li class="breadcrumb-item"><router-link to="/surveys">Surveys</router-link></li>
            <li class="breadcrumb-item active">Survey: {{ survey.survey.title }}</li>
        </ol>
        <div class="subheader">
            <h1 class="subheader-title">
                <i class='subheader-icon fal fa-chart-bar'></i>Edit your Survey<span class='fw-300'></span>
            </h1>

            <div class="subheader-block d-lg-flex align-items-center border-faded border-right-0 border-top-0 border-bottom-0 ml-3 pl-3">
                <div class="d-inline-flex flex-column justify-content-center mr-3">
                    <button class="btn btn-sm btn-danger" @click="cancelEditing(survey._id)">
                        <i class="fa fa-times"></i> Cancel Editing
                    </button>
                </div>
                <span class="sparklines hidden-lg-down" sparkType="bar" sparkBarColor="#fe6bb0" sparkHeight="32px" sparkBarWidth="5px" values="1,4,3,6,5,3,9,6,5,9,7"></span>
            </div>
        </div>
        <div class="panel-tag">
            If your survey is ready to be published, click on <strong>Save Survey > Publish</strong>. Once you change the status and save survey, you cannot edit your questions. <br/><br/>

            <code>Status: </code> <span class="badge badge-primary" style="font-size: 12px; padding: 10px;">Work in Progress</span> <br/><br/>
        </div>
        <div id="surveyCreatorContainer"></div>
    </main>
</template>

<script>
    import * as SurveyCreator from "survey-creator";
    import "survey-creator/survey-creator.css";
    import axios from "axios";
    import Swal from 'sweetalert2'

    export default {
        name: 'SurveyCreator',
        data() {
            return {
                survey: {
                    user: '',
                    survey: {
                        title: '',
                        description: ''
                    },
                    status: ''
                },
            };
        },

        async mounted() {
            let survey = await axios.get(`http://ec2-54-89-84-11.compute-1.amazonaws.com:3000/api/surveyDetails/${this.$route.params.id}`,
                {
                    headers: {
                        'Authorization': `Bearer ${localStorage.getItem('accessToken')}`
                    }
                });

            this.survey = survey.data.data;


            let options = { showEmbededSurveyTab: false };
            this.surveyCreator = new SurveyCreator.SurveyCreator(
                "surveyCreatorContainer",
                options
            );

            this.surveyCreator.text = JSON.stringify(survey.data.data.survey);

            this.surveyCreator.saveSurveyFunc = function() {
                let surveyId = survey.data.data._id;
                Swal.fire({
                    title: 'Publish survey?',
                    text: "You won't be able to edit the form once it is published!",
                    icon: 'warning',
                    showCancelButton: true,
                    confirmButtonColor: '#3085d6',
                    cancelButtonColor: '#d33',
                    confirmButtonText: 'Yes, publish it!',
                    cancelButtonText: 'No, just save it.'
                }).then(async (result) => {

                    if (result.value) {
                        const editedSurvey = {
                            status: 'waitingForApproval',
                            survey: JSON.parse(this.text)
                        };
                        await axios.put(`http://ec2-54-89-84-11.compute-1.amazonaws.com:3000/api/editSurvey/${surveyId}`, editedSurvey,
                            {
                                headers: {
                                    'Authorization': `Bearer ${localStorage.getItem('accessToken')}`
                                }
                            })
                            .then(() => {
                                Swal.fire({
                                    title: 'Survey updated!!',
                                    text: 'Please wait for approval from admin.',
                                    icon: 'success',
                                    confirmButtonColor: '#3085d6',
                                    cancelButtonColor: '#d33',
                                    confirmButtonText: 'Yaayy!',
                                    closeOnClickOutside: false
                                }).then(async (result) => {

                                    if (result.value) {
                                        window.location.href = `/surveys`;
                                    }
                                })

                            })
                            .catch(()=>{
                                Swal.fire({
                                    icon: 'error',
                                    title: 'Oops...',
                                    text: 'Something went wrong!',
                                    showConfirmButton: false,
                                    timer: 1500
                                });
                            });

                        //this.$router.push(`/surveys`);
                    }

                    if (result.dismiss) {
                        const editedSurvey = {
                            survey: JSON.parse(this.text)
                        };
                        await axios.put(`http://ec2-54-89-84-11.compute-1.amazonaws.com:3000/api/editSurvey/${surveyId}`, editedSurvey,
                            {
                                headers: {
                                    'Authorization': `Bearer ${localStorage.getItem('accessToken')}`
                                }
                            })
                            .then(() => {
                                Swal.fire({
                                    title: 'Survey updated!!',
                                    text: 'You can still edit it.',
                                    icon: 'success',
                                    confirmButtonColor: '#3085d6',
                                    cancelButtonColor: '#d33',
                                    confirmButtonText: 'Yaayy!',
                                    closeOnClickOutside: false
                                }).then(async (result) => {

                                    if (result.value) {
                                        window.location.href = `/surveys`;
                                    }
                                })

                            })
                            .catch(()=>{
                                Swal.fire({
                                    icon: 'error',
                                    title: 'Oops...',
                                    text: 'Something went wrong!',
                                    showConfirmButton: false,
                                    timer: 1500
                                });
                            });
                    }
                })

            };
        },

        methods: {
            cancelEditing(id) {
                this.$router.push(`/surveyDetail/${id}`);
            }
        }

    }
</script>

<style scoped>

</style>
